require 'iconv'
require 'hpricot'
require 'open-uri'

$KCODE='u'

class Change
	def initialize(url, time)
		@url, @time = url, time
	end
	def to_s
		"#{@time.strftime("%d/%m/%Y %H:%M")} - #{@url}"
	end
end

MONTHS = {
	"janvier" => 1, "février" => 2,
	"mars" => 3, "avril" => 4, "mai" => 5,
	"juin" => 6, "juillet" => 7, "août" => 8,
	"septembre" => 9, "octobre" => 10, "novembre" => 11,
	"décembre" => 12, "January" => 1, "February" => 2,
	"March" => 3, "April" => 4, "May" => 5, "June" => 6,
	"July" => 7, "August" => 8, "September" => 9, 
	"October" => 10, "November" => 11, "December" => 12
}

url = "http://fsugar.be/pmwiki.php?n=Site.AllRecentChanges"
converter = Iconv.new('UTF-8','ISO-8859-1')
content = converter.iconv(open(url).read)

doc = Hpricot(content)

list = []
doc.search("div#wikitext ul li") do |line|
	url = line.at("a")["href"]
	line.search("a").remove
	date = line.inner_html
	date.match(/.*([0-9]{2}) +(\w+) +([0-9]{4}).+([0-9]{2})h([0-9]{2}).*/)
	day, month, year, hour, min = $1, $2, $3, $4, $5
	month = MONTHS[month]
	time = Time.local(year,month,day,hour,min,0)
	list << Change.new(url, time)
end

list.reverse.each do |c|
	puts c.to_s
end
